//---------------------------------------------------------------------------
#include <vcl.h>
#include "Conduite.h"
#pragma hdrstop
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OpenGLPanel"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
 float a=0;
 GLfloat mvt;
 //--------------------------------------------------------------------------------


 /**********************************************************
 *
 * FUNCTION LoadBitmap(char *)
 *
 * This function loads a bitmap file and return the OpenGL reference ID to use that texture
 *
 *********************************************************/

void LoadBitmap(char *filename, int nb, unsigned char alpha)
{
    int i, j=0; //Index variables
    FILE *l_file; //File pointer
    unsigned char *l_texture; //The pointer to the memory zone in which we will load the texture

    // windows.h gives us these types to work with the Bitmap files
    BITMAPFILEHEADER fileheader;
    BITMAPINFOHEADER infoheader;
    RGBTRIPLE rgb;

    if( (l_file = fopen(filename, "rb"))==NULL) MessageBox(NULL,"Image file: *.bmp not found", "Zetadeck",MB_OK | MB_ICONERROR); // Open the file for reading


    fread(&fileheader, sizeof(fileheader), 1, l_file); // Read the fileheader

    fseek(l_file, sizeof(fileheader), SEEK_SET); // Jump the fileheader
    fread(&infoheader, sizeof(infoheader), 1, l_file); // and read the infoheader

    // Now we need to allocate the memory for our image (width * height * color deep)
    l_texture = (byte *) malloc(infoheader.biWidth * infoheader.biHeight * 4);
    // And fill it with zeros
    memset(l_texture, 0, infoheader.biWidth * infoheader.biHeight * 4);

    // At this point we can read every pixel of the image
    for (i=0; i < infoheader.biWidth*infoheader.biHeight; i++)
    {
            // We load an RGB value from the file
            fread(&rgb, sizeof(rgb), 1, l_file);

            // And store it
            l_texture[j+0] = rgb.rgbtRed; // Red component
            l_texture[j+1] = rgb.rgbtGreen; // Green component
            l_texture[j+2] = rgb.rgbtBlue; // Blue component
            l_texture[j+3] = alpha; // Alpha value
            j += 4; // Go to the next position
    }

    fclose(l_file); // Closes the file stream
    //glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,nb);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);      //GL_LINEAR_MIPMAP_NEAREST
    glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
    glTexImage2D(GL_TEXTURE_2D,0,4,infoheader.biWidth,infoheader.biHeight,0,GL_RGBA,GL_UNSIGNED_BYTE,l_texture);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 256, 256, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 128, 128, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 64, 64, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 32, 32, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 16, 16, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 8, 8, GL_RGBA, GL_UNSIGNED_BYTE, l_texture);
    free(l_texture);
}

 __fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{       dT=0.1;
        x=-30.0f;
        y=-20.0f;
        z=40.0f;
        r=0.0f;
        t=80.0f;
        deltav=0.2;
        deltag=0;
        e=0;
        h=0  ;
        angledrapeau=8;
        TimerAffichage->Interval = 10;
        TimerdT->Interval = dT*1000;

}
//----------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Init(TObject *Sender)
{

        glViewport(0,0,OpenGLPanel1->Width,OpenGLPanel1->Height);
	glMatrixMode(GL_PROJECTION);
        if ( OpenGLPanel1->Height==0)
     	        gluPerspective(70, (GLdouble)OpenGLPanel1->Width, 1.0, 10000.0);
        else
                gluPerspective(70, (GLdouble)OpenGLPanel1->Width/
                           (GLdouble)OpenGLPanel1->Height,1.0, 10000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

        glEnable(GL_DEPTH_TEST);

        //glClearColor(0.8,0.8,1.0,0.1); //ciel
        //glClearDepth(1.0f);							// Depth Buffer Setup
	glDepthFunc(GL_LEQUAL);							// Type Of Depth Testing
	glEnable(GL_DEPTH_TEST);						// Enable Depth Testing

        GLfloat LightAmbient[]={ 1.0,1.0,1.0,1.0};
        GLfloat LightDiffuse[]={ 1.0f, 1.0f, 1.0f, 1.0f };
        GLfloat light_specular[]={1.0,1.0,1.0,1.0};
        GLfloat LightPosition[]= {10.0f,10.0f,10.0f, 0.0f };
        glEnable(GL_LIGHTING);
        glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
        glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
        glLightfv(GL_LIGHT0,GL_SPECULAR,light_specular);
        glLightfv(GL_LIGHT0, GL_POSITION,LightPosition);
	glEnable(GL_LIGHT0);
//        glEnable(GL_TEXTURE_2D);
        LoadBitmap("texture2.bmp", 0, 200);
        LoadBitmap("sky.bmp", 1, 200);
        LoadBitmap("voile.bmp", 2, 250);
        LoadBitmap("bois.bmp",3, 255);
        LoadBitmap("bois2.bmp",4,255);
        LoadBitmap("bois10.bmp",5,255);
        LoadBitmap("bois13.bmp",6,255);
        LoadBitmap("bois7.bmp",7,255);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Paint(TObject *Sender)
{       glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
     	glLoadIdentity();
        char temp[255];
       sprintf(temp,"dT = %f et V=%f",
                  dT ,Bateau1.V);
       Memo1->Text=temp;
        Bateau1.V=TrackBar5->Position;
        h= TrackBar4->Position ;
        z= TrackBar6->Position ;
        x+=h*cos(e*DegToRad)/100;
        y+=-h*sin(e*DegToRad)/100;
        e=TrackBar3->Position ;
        gluLookAt(x,y,z,x+100*cos(e*DegToRad),y-100*sin(e*DegToRad),0,0,0,1);
        GLfloat amb[4] = { 1, 1, 1, 0.5 };
        GLfloat dif[4] = { 1.0, 1.0, 1.0, 0.5 };
        GLfloat spec[4] = { 2, 2, 2, 1.0 };

        glEnable(GL_COLOR_MATERIAL);      // reflet
        //glRotatef(1, 0,0,1);
        glTranslatef(x,y,z);
        glEnable(GL_TEXTURE_2D);         //ciel
        glBindTexture(GL_TEXTURE_2D,1);
        GLUquadricObj*q1=gluNewQuadric();
        gluQuadricOrientation(q1, GLU_INSIDE);
        //gluQuadricDrawStyle(q1,GLU_FILL);
        gluQuadricTexture(q1, GL_TRUE);
        gluSphere(q1,1000.0,128,128);
        gluDeleteQuadric(q1);
        glDisable(GL_TEXTURE_2D);
        glTranslatef(-x,-y,-z);
        //glRotatef(-1, 0,0,1);

        glMaterialfv(GL_FRONT, GL_DIFFUSE, dif);
        glMaterialfv(GL_FRONT, GL_AMBIENT, amb);
        glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
        glMaterialf(GL_FRONT, GL_SHININESS, 25.0);

      	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);			// Enable Alpha Blending (disable alpha testing)
	glEnable(GL_BLEND);

        //mvt = (rand()%100/80 +mvt)/2;
        //glTranslatef(0,0, mvt);
        glColor3f(0.6,0,0);   //         Sphere rouge
        GLUquadricObj* q=gluNewQuadric();
        gluQuadricDrawStyle(q,GLU_FILL);
        gluSphere(q,1.0,10,10);
        gluDeleteQuadric(q);
        //glTranslatef(0,0, -mvt);


        angledrapeau= -angledrapeau; //dessiner le drapeau
        glPushMatrix();
        glRotatef(angledrapeau,0,0,1);
        glBegin(GL_POLYGON);
        glColor3f(0,0.7,0);
        glVertex3f(0,0,15);   glVertex3f(0,-4,14); glVertex3f(0,0,13);
        glEnd();
        glPopMatrix();


        /*glLineWidth(4);    //poteau
        glBegin(GL_LINES);
        glColor3f(0,0,0);
        glVertex3f(0,0,0);  glVertex3f(0,0,15);
        glEnd(); */

        //glEnable(GL_TEXTURE_2D);         //mt
        //glBindTexture(GL_TEXTURE_2D,5);
        glColor3f(0,0,0);
        q1=gluNewQuadric();
        gluQuadricOrientation(q1, GLU_OUTSIDE);
        //gluQuadricDrawStyle(q1,GLU_FILL);
        //gluQuadricTexture(q1, GL_TRUE);
        gluCylinder(q1,0.08,0.08,15, 10,10);
        gluDeleteQuadric(q1);
        //glDisable(GL_TEXTURE_2D);

        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D,0);
        glBegin(GL_POLYGON); //mer
                glColor3f(0,0.7,1);

                glTexCoord2f(10.0,10.0);
                glVertex3f(-10000,-10000,0);

                glTexCoord2f(0.0,10.0);
                glVertex3f(10000,-10000,0);

                glTexCoord2f(0.0,0.0);
                glVertex3f(10000,10000,0);

                glTexCoord2f(10.0,0.0);
                glVertex3f(-10000,10000,0);
        glEnd();
        glDisable(GL_TEXTURE_2D);
        glEnable( GL_NORMALIZE );
        Bateau1.Draw();

        glPopMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartClick(TObject *Sender)
        {        deltav=0.2;
                 deltag=0;
                 Bateau1=Bateau();
        }
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerAffichageClock(TObject *Sender)
    {   OpenGLPanel1->Repaint();
        char temp[255];
        sprintf(temp,"%f",Bateau1.etat.v);              Form1->Edit2->Text=temp;
        sprintf(temp,"%f",Bateau1.etat.x);              Form1->Edit3->Text=temp;
        sprintf(temp,"%f",Bateau1.etat.y);              Form1->Edit4->Text=temp;
        sprintf(temp,"%f",Bateau1.etat.theta*RadToDeg); Form1->Edit5->Text=temp;
        sprintf(temp,"%f",Bateau1.etat.omega);          Form1->Edit6->Text=temp;
        sprintf(temp,"%f",Bateau1.fv);                  Form1->Edit7->Text=temp;
        sprintf(temp,"%f",Bateau1.fg);                  Form1->Edit8->Text=temp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerdTClock(TObject *Sender)
{
       Bateau1.Incremente(dT,deltav,deltag);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartKeyPress(TObject *Sender, char &Key)
{switch (Key)
 {
   case 'w': deltav=deltav-0.1;    break;      //voile
   case 'q': deltav=deltav+0.1;    break;
   case 'n': deltag=deltag-0.1;    break;      //voile
   case 'j': deltag=deltag+0.1;    break;
 }
}
//---------------------------------------------------------------------------




